import { Schema } from 'mongoose';
import { IMongooseNamingStrategyOptions, TProcessTransform } from './interfaces';
export * from './constants';
export * from './interfaces';
export declare class MongooseNamingStrategy {
    #private;
    constructor(opts: IMongooseNamingStrategyOptions);
    setAuloload(enabled: boolean): this;
    setSchemaToDb(fn: TProcessTransform): this;
    setDbToSchema(fn: TProcessTransform): this;
    setJSToSchema(fn: TProcessTransform): this;
    setSchemaToJS(fn: TProcessTransform): this;
    useLogger(level?: boolean | string[], console?: Console): this;
    addExclusions(...val: string[]): this;
    getExclusions(): string[];
    removeExclusions(...val: string[]): this;
    useLeanSignature(signature: string | symbol | false): this;
    useRunSignature(signature: string | symbol): this;
    addCustomMapping(key: string, value: string): this;
    useCheckTransformSignature(key: string): this;
    useKeepPropertySignature(key: string): this;
    private generateNamingTransformation;
    private makePreTransform;
    private attachVirtual;
    private attachTransform;
    private attachDistinctHook;
    private attachCountHook;
    private attachPostLeanHook;
    private attachDocumentHooks;
    private attachUpdateHooks;
    private attachRemoveHook;
    getPlugin(): (schema: Schema) => void;
    private getSchemaCustomMapping;
    private requiredPipeline;
    private makePreTransformPipeline;
    private makePostTransformPipeline;
    static AddExclusion(schema: Schema, val: string): void;
    static AddCustomMappings(schema: Schema, key: string, val: string): void;
    static ExcludeOne(schema: Schema): void;
}
