"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var _autoload, _exclusions, _customMapping, _runSignature, _schemaToDb, _handlePreTransform, _handlePostTransform, _logger, _leanSignature, _checkTransform, _keep, _checkSkipTransform;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongooseNamingStrategy = void 0;
const interfaces_1 = require("./interfaces");
const constants_1 = require("./constants");
const utils_1 = require("./utils");
const logger_1 = require("./utils/logger");
const pipeline_1 = require("./utils/pipeline");
__exportStar(require("./constants"), exports);
__exportStar(require("./interfaces"), exports);
class MongooseNamingStrategy {
    constructor(opts) {
        _autoload.set(this, true);
        _exclusions.set(this, void 0);
        _customMapping.set(this, new Map());
        _runSignature.set(this, void 0);
        _schemaToDb.set(this, false);
        _handlePreTransform.set(this, void 0);
        _handlePostTransform.set(this, void 0);
        _logger.set(this, void 0);
        _leanSignature.set(this, void 0);
        _checkTransform.set(this, '@@check-transform');
        _keep.set(this, '@@keep');
        // eslint-disable-next-line class-methods-use-this
        _checkSkipTransform.set(this, (obj) => {
            const skip = !!obj[__classPrivateFieldGet(this, _checkTransform)];
            // eslint-disable-next-line no-param-reassign
            if (skip)
                delete obj[__classPrivateFieldGet(this, _checkTransform)];
            return skip;
        });
        const { autoload, exclusions: exclusion, schemaType, runSignature, leanSignature, logger, camelToSnake: customCamelToSnake, snakeToCamel: customSnakeToCamel, } = opts;
        __classPrivateFieldSet(this, _logger, logger_1.createLogger(logger || true));
        __classPrivateFieldSet(this, _autoload, autoload);
        if (schemaType === interfaces_1.ENaming.CAMEL_CASE) {
            __classPrivateFieldSet(this, _handlePreTransform, this.generateNamingTransformation(customCamelToSnake || utils_1.camelToSnake));
            __classPrivateFieldSet(this, _handlePostTransform, this.generateNamingTransformation(customSnakeToCamel || utils_1.snakeToCamel));
        }
        else {
            __classPrivateFieldSet(this, _handlePreTransform, this.generateNamingTransformation(customSnakeToCamel || utils_1.snakeToCamel));
            __classPrivateFieldSet(this, _handlePostTransform, this.generateNamingTransformation(customCamelToSnake || utils_1.camelToSnake));
        }
        if (exclusion)
            __classPrivateFieldSet(this, _exclusions, exclusion);
        else
            __classPrivateFieldSet(this, _exclusions, ['_id', '__v']);
        if (runSignature)
            __classPrivateFieldSet(this, _runSignature, runSignature);
        else
            __classPrivateFieldSet(this, _runSignature, constants_1.SIGNATURE.RUN);
        if (leanSignature)
            __classPrivateFieldSet(this, _leanSignature, leanSignature);
        else
            __classPrivateFieldSet(this, _leanSignature, constants_1.SIGNATURE.LEAN_QUERY);
    }
    setAuloload(enabled) {
        __classPrivateFieldSet(this, _autoload, enabled);
        return this;
    }
    setSchemaToDb(fn) {
        __classPrivateFieldSet(this, _handlePostTransform, this.generateNamingTransformation(fn));
        if (!__classPrivateFieldGet(this, _schemaToDb)) {
            __classPrivateFieldGet(this, _logger).warn('Calling setSchemaToDb() will override all application transformations includes virtual properties');
            __classPrivateFieldSet(this, _schemaToDb, true);
        }
        return this;
    }
    setDbToSchema(fn) {
        __classPrivateFieldSet(this, _handlePreTransform, this.generateNamingTransformation(fn));
        if (!__classPrivateFieldGet(this, _schemaToDb)) {
            __classPrivateFieldGet(this, _logger).warn('Calling setDbToSchema() will override all application transformations includes virtual properties');
            __classPrivateFieldSet(this, _schemaToDb, true);
        }
        return this;
    }
    setJSToSchema(fn) {
        __classPrivateFieldSet(this, _handlePostTransform, this.generateNamingTransformation(fn));
        if (__classPrivateFieldGet(this, _schemaToDb)) {
            __classPrivateFieldGet(this, _logger).warn('Calling setJSToSchema() will override all direct schema transformation to DB');
            __classPrivateFieldSet(this, _schemaToDb, false);
        }
        return this;
    }
    setSchemaToJS(fn) {
        __classPrivateFieldSet(this, _handlePreTransform, this.generateNamingTransformation(fn));
        if (__classPrivateFieldGet(this, _schemaToDb)) {
            __classPrivateFieldGet(this, _logger).warn('Calling setSchemaToJS() will override all direct schema transformations to DB');
            __classPrivateFieldSet(this, _schemaToDb, false);
        }
        return this;
    }
    useLogger(level = true, console) {
        __classPrivateFieldSet(this, _logger, logger_1.createLogger(level, console));
        return this;
    }
    addExclusions(...val) {
        val.forEach((e) => {
            if (__classPrivateFieldGet(this, _exclusions).findIndex((v) => v === e) === -1)
                __classPrivateFieldGet(this, _exclusions).push(e);
        });
        return this;
    }
    getExclusions() {
        return __classPrivateFieldGet(this, _exclusions);
    }
    removeExclusions(...val) {
        __classPrivateFieldSet(this, _exclusions, __classPrivateFieldGet(this, _exclusions).filter((e) => val.findIndex((v) => e === v) === -1));
        return this;
    }
    useLeanSignature(signature) {
        if (signature) {
            __classPrivateFieldSet(this, _autoload, false);
        }
        __classPrivateFieldSet(this, _leanSignature, signature);
        return this;
    }
    useRunSignature(signature) {
        __classPrivateFieldSet(this, _autoload, false);
        __classPrivateFieldSet(this, _runSignature, signature);
        return this;
    }
    addCustomMapping(key, value) {
        __classPrivateFieldGet(this, _customMapping).set(key, value);
        return this;
    }
    useCheckTransformSignature(key) {
        __classPrivateFieldSet(this, _checkTransform, key);
        return this;
    }
    useKeepPropertySignature(key) {
        __classPrivateFieldSet(this, _keep, key);
        return this;
    }
    generateNamingTransformation(fn) {
        return (str) => {
            if (__classPrivateFieldGet(this, _customMapping)) {
                const val = __classPrivateFieldGet(this, _customMapping).get(str);
                if (val)
                    return val;
            }
            if (__classPrivateFieldGet(this, _exclusions).find((e) => e === str))
                return str;
            if (str.startsWith('$'))
                return str;
            return fn(str);
        };
    }
    makePreTransform(schema) {
        if (Object.getOwnPropertySymbols(schema).find((k) => k === constants_1.KEYS.KEY_MAPPERS))
            return;
        const handler = this.requiredPipeline(schema)
            ? this.makePreTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePreTransform);
        const { tree } = schema;
        const keyMappers = Object.entries(tree).reduce((acc, [cur, curValue]) => {
            if (curValue &&
                typeof curValue === 'object' &&
                curValue.constructor.name === 'VirtualType')
                return acc;
            acc[handler(cur)] = cur;
            return acc;
        }, {});
        Object.defineProperty(schema, constants_1.KEYS.KEY_MAPPERS, {
            writable: false,
            value: keyMappers,
        });
        Object.defineProperty(schema, constants_1.KEYS.FN_TRANSFORM_JSON, {
            writable: false,
            value: utils_1.makeTransform(keyMappers, { toJSON: true }),
        });
        Object.defineProperty(schema, constants_1.KEYS.FN_TRANSFORM_OBJ, {
            writable: false,
            value: utils_1.makeTransform(keyMappers, { toJSON: false }),
        });
    }
    // eslint-disable-next-line class-methods-use-this
    attachVirtual(schema) {
        if (schema[constants_1.KEYS.HAS_VIRTUAL]) {
            return;
        }
        const mappers = schema[constants_1.KEYS.KEY_MAPPERS];
        if (!mappers)
            return;
        Object.entries(mappers).forEach(([key, value]) => {
            if (key !== value) {
                schema
                    .virtual(key)
                    .get(function () {
                    return this[value];
                })
                    .set(function (val) {
                    this[value] = val;
                });
            }
        });
        Object.defineProperty(schema, constants_1.KEYS.HAS_VIRTUAL, {
            writable: false,
            value: true,
        });
    }
    // eslint-disable-next-line class-methods-use-this
    attachTransform(schema) {
        const transformJSON = schema[constants_1.KEYS.FN_TRANSFORM_JSON];
        const transformObj = schema[constants_1.KEYS.FN_TRANSFORM_OBJ];
        schema.set('toJSON', {
            transform(doc) {
                return transformJSON(doc);
            },
        });
        schema.set('toObject', {
            transform(doc) {
                return transformObj(doc);
            },
        });
    }
    attachDistinctHook(schema) {
        const handler = this.requiredPipeline(schema)
            ? this.makePostTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePostTransform);
        schema.pre('distinct', function (next) {
            const distinct = this._distinct;
            if (distinct && typeof distinct === 'string') {
                this._distinct = handler(distinct);
            }
            next();
        });
    }
    attachCountHook(schema) {
        const handler = this.requiredPipeline(schema)
            ? this.makePostTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePostTransform);
        schema.pre('countDocuments', function (next) {
            const conditions = this._conditions;
            if (utils_1.isObject(conditions)) {
                this._conditions = utils_1.deepTransform(conditions, handler);
            }
            next();
        });
    }
    attachPostLeanHook(schema) {
        const self = this;
        const handler = this.requiredPipeline(schema)
            ? this.makePreTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePreTransform);
        // eslint-disable-next-line func-names
        schema.post(/^find/, function (res, next) {
            var _a;
            if (!this._mongooseOptions.lean) {
                return next();
            }
            if (__classPrivateFieldGet(self, _leanSignature) &&
                !((_a = this._mongooseOptions) === null || _a === void 0 ? void 0 : _a.lean[__classPrivateFieldGet(self, _leanSignature)])) {
                return next();
            }
            if (!__classPrivateFieldGet(self, _autoload))
                return next();
            if (Array.isArray(res)) {
                for (let i = 0; i < res.length; i++) {
                    const doc = res[i];
                    res[i] = utils_1.deepTransform(doc, handler);
                }
                return next();
            }
            if (utils_1.isObject(res)) {
                utils_1.deepTransform(res, handler, true);
            }
            next();
        });
    }
    attachDocumentHooks(schema) {
        const handler = this.requiredPipeline(schema)
            ? this.makePostTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePostTransform);
        const self = this;
        schema.pre(/^find/, function (next) {
            const conditions = this._conditions;
            const fields = this._fields;
            const { options } = this;
            const updateDoc = this._update;
            if (utils_1.isObject(conditions)) {
                if (__classPrivateFieldGet(self, _checkSkipTransform).call(self, conditions)) {
                    this._conditions = utils_1.deepTransform(conditions, handler, false, __classPrivateFieldGet(self, _keep));
                }
                else {
                    this._conditions = utils_1.deepTransform(conditions, handler);
                }
            }
            if (utils_1.isObject(fields)) {
                this._fields = utils_1.deepTransform(fields, handler);
            }
            if (utils_1.isObject(options)) {
                Object.entries(options).forEach(([key, value]) => {
                    if (utils_1.isObject(value)) {
                        this.options[key] = utils_1.deepTransform(value, handler);
                    }
                    else
                        this.options[key] = value;
                });
            }
            if (utils_1.isObject(updateDoc)) {
                if (__classPrivateFieldGet(self, _checkSkipTransform).call(self, updateDoc)) {
                    this._update = utils_1.deepTransform(updateDoc, handler, false, __classPrivateFieldGet(self, _keep));
                }
                else {
                    this._update = utils_1.deepTransform(updateDoc, handler);
                }
            }
            next();
        });
    }
    attachUpdateHooks(schema) {
        const self = this;
        const handler = this.requiredPipeline(schema)
            ? this.makePostTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePostTransform);
        schema.pre(/^update/, function (next) {
            const update = this._update;
            const conditions = this._conditions;
            if (utils_1.isObject(update)) {
                if (__classPrivateFieldGet(self, _checkSkipTransform).call(self, update)) {
                    this._update = utils_1.deepTransform(update, handler, false, __classPrivateFieldGet(self, _keep));
                }
                else {
                    this._update = utils_1.deepTransform(update, handler);
                }
            }
            if (utils_1.isObject(conditions)) {
                if (__classPrivateFieldGet(self, _checkSkipTransform).call(self, conditions)) {
                    this._conditions = utils_1.deepTransform(conditions, handler, false, __classPrivateFieldGet(self, _keep));
                }
                else {
                    this._conditions = utils_1.deepTransform(conditions, handler);
                }
            }
            next();
        });
    }
    attachRemoveHook(schema) {
        const handler = this.requiredPipeline(schema)
            ? this.makePostTransformPipeline(schema)
            : __classPrivateFieldGet(this, _handlePostTransform);
        schema.pre(/^delete/, function (next) {
            const conditions = this._conditions;
            if (utils_1.isObject(conditions)) {
                this._conditions = utils_1.deepTransform(conditions, handler);
            }
            next();
        });
    }
    getPlugin() {
        return (schema) => {
            if (Object.getOwnPropertySymbols(schema).includes(constants_1.KEYS.EXCLUDE_SCHEMA)) {
                return;
            }
            const mappers = schema[constants_1.KEYS.KEY_MAPPERS];
            if (mappers)
                return;
            this.makePreTransform(schema);
            this.attachVirtual(schema);
            this.attachTransform(schema);
            this.attachCountHook(schema);
            this.attachDistinctHook(schema);
            this.attachDocumentHooks(schema);
            this.attachUpdateHooks(schema);
            this.attachRemoveHook(schema);
            this.attachPostLeanHook(schema);
        };
    }
    // eslint-disable-next-line class-methods-use-this
    getSchemaCustomMapping(schema, prop) {
        const exclusions = schema[constants_1.KEYS.SCHEMA_EXCLUSIONS];
        const mappers = schema[constants_1.KEYS.SCHEMA_CUSTOM_MAPPINGS];
        if (exclusions) {
            if (exclusions.includes(prop)) {
                return prop;
            }
        }
        if (mappers) {
            const found = mappers.get(prop);
            if (found)
                return found;
        }
        return false;
    }
    // eslint-disable-next-line class-methods-use-this
    requiredPipeline(schema) {
        return (schema[constants_1.KEYS.SCHEMA_CUSTOM_MAPPINGS] ||
            schema[constants_1.KEYS.SCHEMA_EXCLUSIONS]);
    }
    makePreTransformPipeline(schema) {
        if (schema[constants_1.KEYS.SCHEMA_CACHE_PRE]) {
            return schema[constants_1.KEYS.SCHEMA_CACHE_PRE];
        }
        const handler = pipeline_1.pipeline((k) => this.getSchemaCustomMapping(schema, k), __classPrivateFieldGet(this, _handlePreTransform));
        Object.defineProperty(schema, constants_1.KEYS.SCHEMA_CACHE_PRE, {
            value: handler,
        });
        return handler;
    }
    makePostTransformPipeline(schema) {
        if (schema[constants_1.KEYS.SCHEMA_CACHE_POST]) {
            return schema[constants_1.KEYS.SCHEMA_CACHE_POST];
        }
        const handler = pipeline_1.pipeline((k) => this.getSchemaCustomMapping(schema, k), __classPrivateFieldGet(this, _handlePostTransform));
        Object.defineProperty(schema, constants_1.KEYS.SCHEMA_CACHE_POST, {
            value: handler,
        });
        return handler;
    }
    static AddExclusion(schema, val) {
        if (!schema[constants_1.KEYS.SCHEMA_EXCLUSIONS]) {
            // eslint-disable-next-line no-param-reassign
            schema[constants_1.KEYS.SCHEMA_EXCLUSIONS] = [val];
        }
        // eslint-disable-next-line no-param-reassign
        schema[constants_1.KEYS.SCHEMA_EXCLUSIONS].push(val);
    }
    static AddCustomMappings(schema, key, val) {
        if (!schema[constants_1.KEYS.SCHEMA_CUSTOM_MAPPINGS]) {
            // eslint-disable-next-line no-param-reassign
            schema[constants_1.KEYS.SCHEMA_CUSTOM_MAPPINGS] = new Map();
        }
        schema[constants_1.KEYS.SCHEMA_CUSTOM_MAPPINGS].set(key, val);
    }
    static ExcludeOne(schema) {
        Object.defineProperty(schema, constants_1.KEYS.EXCLUDE_SCHEMA, {
            value: true,
            writable: false,
        });
    }
}
exports.MongooseNamingStrategy = MongooseNamingStrategy;
_autoload = new WeakMap(), _exclusions = new WeakMap(), _customMapping = new WeakMap(), _runSignature = new WeakMap(), _schemaToDb = new WeakMap(), _handlePreTransform = new WeakMap(), _handlePostTransform = new WeakMap(), _logger = new WeakMap(), _leanSignature = new WeakMap(), _checkTransform = new WeakMap(), _keep = new WeakMap(), _checkSkipTransform = new WeakMap();
