"use strict";
/* eslint-disable no-console */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLogger = void 0;
const createLogger = (level, console) => {
    const ctxConsole = console || global.console;
    if (!level) {
        return {
            log: (...args) => null,
            warn: (...args) => null,
        };
    }
    if (level && typeof level === 'boolean') {
        return {
            log: ctxConsole.log.bind(null, '[MongooseNamingStrategy]'),
            warn: ctxConsole.warn.bind(null, '[MongooseNamingStrategy]'),
        };
    }
    const result = {};
    ['log', 'warn']
        .map((e) => ({
        method: e,
        enable: level.indexOf(e) !== -1,
    }))
        .forEach(({ enable, method }) => {
        result[method] = enable
            ? ctxConsole[method].bind(null, '[MongooseNamingStrategy]')
            : (...args) => null;
    });
    return result;
};
exports.createLogger = createLogger;
