"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isObjectId = exports.isMongooseExtendedDeclaration = void 0;
const isMongooseExtendedDeclaration = (obj) => typeof obj === 'object' &&
    obj !== null &&
    obj.constructor.name === 'Object' &&
    typeof obj.type === 'object' &&
    obj.type === 'Function';
exports.isMongooseExtendedDeclaration = isMongooseExtendedDeclaration;
const isObjectId = (obj) => {
    if (typeof obj !== 'object')
        return false;
    if (obj === null)
        return false;
    if (obj._bsontype &&
        obj._bsontype === 'ObjectID' &&
        obj.id) {
        return true;
    }
    return false;
};
exports.isObjectId = isObjectId;
